
#include "../precompiled.h" //always first
#include "nayrusLove.h"

#include "../link.h"
#include "../zdefs.h"
#include "../zelda.h"

NayrusLoveAction::NayrusLoveAction(int itemID, LinkClass& l):
    phase(0),
    timer(0),
    link(l)
{
    magicitem=itemID;
}

NayrusLoveAction::~NayrusLoveAction()
{
    rocket1.del();
    rocket2.del();
    magicitem=-1;
}

void NayrusLoveAction::update()
{
    addsparkle2(pNAYRUSLOVEROCKET1,pNAYRUSLOVEROCKETTRAIL1);
    addsparkle2(pNAYRUSLOVEROCKET2,pNAYRUSLOVEROCKETTRAIL2);
    addsparkle2(pNAYRUSLOVEROCKETRETURN1,pNAYRUSLOVEROCKETTRAILRETURN1);
    addsparkle2(pNAYRUSLOVEROCKETRETURN2,pNAYRUSLOVEROCKETTRAILRETURN2);
    
    if(timer>0)
    {
        timer--;
        return;
    }
    
    // See also link.cpp, LinkClass::checkhit().
    switch(phase)
    {
    case 0:
        rocket1.reset(new weapon(LinkX(),LinkY(),(fix)0,wPhantom,pNAYRUSLOVEROCKET1,0,left, magicitem, link.getUID()));
        rocket1->LOADGFX(itemsbuf[magicitem].wpn);
        rocket1->step=4;
        Lwpns.add(rocket1.get());
        
        rocket2.reset(new weapon(LinkX(),LinkY(),(fix)0,wPhantom,pNAYRUSLOVEROCKET2,0,right, magicitem, link.getUID()));
        rocket2->LOADGFX(itemsbuf[magicitem].wpn6);
        rocket2->step=4;
        Lwpns.add(rocket2.get());
        
        if(get_bit(quest_rules,qr_MORESOUNDS))
            sfx(WAV_ZN1ROCKETUP, pan(link.getX()));
        
        linktile(&link.tile, &link.flip, &link.extend, ls_cast, link.getDir(), zinit.linkanimationstyle);
        
        if(get_bit(quest_rules,qr_EXPANDEDLTM))
            link.tile+=item_tile_mod();
        
        phase=1;
        timer=64;
        break;
        
    case 1:
        rocket1->dir=right;
        rocket1->type=pNAYRUSLOVEROCKETRETURN1;
        rocket1->LOADGFX(itemsbuf[magicitem].wpn2);
        
        rocket2->dir=left;
        rocket2->type=pNAYRUSLOVEROCKETRETURN2;
        rocket2->LOADGFX(itemsbuf[magicitem].wpn7);
        
        if(get_bit(quest_rules,qr_MORESOUNDS))
            sfx(WAV_ZN1ROCKETDOWN, pan(link.getX()));
        
        linktile(&link.tile, &link.flip, &link.extend, ls_cast, link.getDir(), zinit.linkanimationstyle);
        
        if(get_bit(quest_rules,qr_EXPANDEDLTM))
            link.tile+=item_tile_mod();
        
        phase=3;
        break;
            
    case 3:
        if(rocket1->getX()<link.getX())
            break;
        
        rocket1.del();
        rocket2.del();
        
        linktile(&link.tile, &link.flip, &link.extend, ls_landhold2, link.getDir(), zinit.linkanimationstyle);
        
        if(get_bit(quest_rules,qr_EXPANDEDLTM))
            link.tile+=item_tile_mod();
        
        link.setNayrusLoveShieldClk(itemsbuf[magicitem].misc1);
        
        if(get_bit(quest_rules,qr_MORESOUNDS))
        {
            if(nayruitem != -1)
            {
                stop_sfx(itemsbuf[nayruitem].usesound+1);
                stop_sfx(itemsbuf[nayruitem].usesound);
            }
            
            cont_sfx(itemsbuf[magicitem].usesound);
        }
        
        phase=4;
        timer=32;
        nayruitem = magicitem;
        break;
        
    case 4:
        // Just waiting for the timer...
        phase=5;
        break;
    }
}

bool NayrusLoveAction::isFinished() const
{
    return phase==5;
}

void NayrusLoveAction::abort()
{
    rocket1.del();
    rocket2.del();
}
